/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-image-view2-2.0.3-0raring-20150728-0048/msg/MouseEvent.msg
 *
 */


#ifndef IMAGE_VIEW2_MESSAGE_MOUSEEVENT_H
#define IMAGE_VIEW2_MESSAGE_MOUSEEVENT_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>

namespace image_view2
{
template <class ContainerAllocator>
struct MouseEvent_
{
  typedef MouseEvent_<ContainerAllocator> Type;

  MouseEvent_()
    : header()
    , type(0)
    , key(0)
    , x(0)
    , y(0)
    , width(0)
    , height(0)  {
    }
  MouseEvent_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , type(0)
    , key(0)
    , x(0)
    , y(0)
    , width(0)
    , height(0)  {
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef int32_t _type_type;
  _type_type type;

   typedef int32_t _key_type;
  _key_type key;

   typedef int32_t _x_type;
  _x_type x;

   typedef int32_t _y_type;
  _y_type y;

   typedef int32_t _width_type;
  _width_type width;

   typedef int32_t _height_type;
  _height_type height;


    enum { KEY_PRESSED = 1 };
     enum { MOUSE_LEFT_UP = 2 };
     enum { MOUSE_LEFT_DOWN = 3 };
     enum { MOUSE_MOVE = 4 };
     enum { MOUSE_RIGHT_DOWN = 5 };
 

  typedef boost::shared_ptr< ::image_view2::MouseEvent_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::image_view2::MouseEvent_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct MouseEvent_

typedef ::image_view2::MouseEvent_<std::allocator<void> > MouseEvent;

typedef boost::shared_ptr< ::image_view2::MouseEvent > MouseEventPtr;
typedef boost::shared_ptr< ::image_view2::MouseEvent const> MouseEventConstPtr;

// constants requiring out of line definition

   

   

   

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::image_view2::MouseEvent_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::image_view2::MouseEvent_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace image_view2

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'image_view2': ['/tmp/buildd/ros-hydro-image-view2-2.0.3-0raring-20150728-0048/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::image_view2::MouseEvent_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::image_view2::MouseEvent_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::image_view2::MouseEvent_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::image_view2::MouseEvent_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::image_view2::MouseEvent_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::image_view2::MouseEvent_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::image_view2::MouseEvent_<ContainerAllocator> >
{
  static const char* value()
  {
    return "7ffa73624c1be385169a9e6e23460224";
  }

  static const char* value(const ::image_view2::MouseEvent_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x7ffa73624c1be385ULL;
  static const uint64_t static_value2 = 0x169a9e6e23460224ULL;
};

template<class ContainerAllocator>
struct DataType< ::image_view2::MouseEvent_<ContainerAllocator> >
{
  static const char* value()
  {
    return "image_view2/MouseEvent";
  }

  static const char* value(const ::image_view2::MouseEvent_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::image_view2::MouseEvent_<ContainerAllocator> >
{
  static const char* value()
  {
    return "Header header\n\
\n\
# event type\n\
int32 KEY_PRESSED=1\n\
int32 MOUSE_LEFT_UP=2\n\
int32 MOUSE_LEFT_DOWN=3\n\
int32 MOUSE_MOVE=4\n\
int32 MOUSE_RIGHT_DOWN=5\n\
int32 type\n\
\n\
int32 key\n\
\n\
# location of mouse\n\
int32 x\n\
int32 y\n\
\n\
# size of image\n\
int32 width\n\
int32 height\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
";
  }

  static const char* value(const ::image_view2::MouseEvent_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::image_view2::MouseEvent_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.type);
      stream.next(m.key);
      stream.next(m.x);
      stream.next(m.y);
      stream.next(m.width);
      stream.next(m.height);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct MouseEvent_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::image_view2::MouseEvent_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::image_view2::MouseEvent_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "type: ";
    Printer<int32_t>::stream(s, indent + "  ", v.type);
    s << indent << "key: ";
    Printer<int32_t>::stream(s, indent + "  ", v.key);
    s << indent << "x: ";
    Printer<int32_t>::stream(s, indent + "  ", v.x);
    s << indent << "y: ";
    Printer<int32_t>::stream(s, indent + "  ", v.y);
    s << indent << "width: ";
    Printer<int32_t>::stream(s, indent + "  ", v.width);
    s << indent << "height: ";
    Printer<int32_t>::stream(s, indent + "  ", v.height);
  }
};

} // namespace message_operations
} // namespace ros

#endif // IMAGE_VIEW2_MESSAGE_MOUSEEVENT_H
