# generated from catkin/cmake/template/pkgConfig.cmake.in

# append elements to a list and remove existing duplicates from the list
# copied from catkin/cmake/list_append_deduplicate.cmake to keep pkgConfig
# self contained
macro(_list_append_deduplicate listname)
  if(NOT "${ARGN}" STREQUAL "")
    if(${listname})
      list(REMOVE_ITEM ${listname} ${ARGN})
    endif()
    list(APPEND ${listname} ${ARGN})
  endif()
endmacro()

# append elements to a list if they are not already in the list
# copied from catkin/cmake/list_append_unique.cmake to keep pkgConfig
# self contained
macro(_list_append_unique listname)
  foreach(_item ${ARGN})
    list(FIND ${listname} ${_item} _index)
    if(_index EQUAL -1)
      list(APPEND ${listname} ${_item})
    endif()
  endforeach()
endmacro()

# pack a list of libraries with optional build configuration keywords
# copied from catkin/cmake/catkin_libraries.cmake to keep pkgConfig
# self contained
macro(_pack_libraries_with_build_configuration VAR)
  set(${VAR} "")
  set(_argn ${ARGN})
  list(LENGTH _argn _count)
  set(_index 0)
  while(${_index} LESS ${_count})
    list(GET _argn ${_index} lib)
    if("${lib}" MATCHES "^debug|optimized|general$")
      math(EXPR _index "${_index} + 1")
      if(${_index} EQUAL ${_count})
        message(FATAL_ERROR "_pack_libraries_with_build_configuration() the list of libraries '${ARGN}' ends with '${lib}' which is a build configuration keyword and must be followed by a library")
      endif()
      list(GET _argn ${_index} library)
      list(APPEND ${VAR} "${lib}${CATKIN_BUILD_CONFIGURATION_KEYWORD_SEPARATOR}${library}")
    else()
      list(APPEND ${VAR} "${lib}")
    endif()
    math(EXPR _index "${_index} + 1")
  endwhile()
endmacro()

# unpack a list of libraries with optional build configuration keyword prefixes
# copied from catkin/cmake/catkin_libraries.cmake to keep pkgConfig
# self contained
macro(_unpack_libraries_with_build_configuration VAR)
  set(${VAR} "")
  foreach(lib ${ARGN})
    string(REGEX REPLACE "^(debug|optimized|general)${CATKIN_BUILD_CONFIGURATION_KEYWORD_SEPARATOR}(.+)$" "\\1;\\2" lib "${lib}")
    list(APPEND ${VAR} "${lib}")
  endforeach()
endmacro()


if(image_view2_CONFIG_INCLUDED)
  return()
endif()
set(image_view2_CONFIG_INCLUDED TRUE)

# set variables for source/devel/install prefixes
if("FALSE" STREQUAL "TRUE")
  set(image_view2_SOURCE_PREFIX /tmp/buildd/ros-hydro-image-view2-2.0.3-0raring-20150728-0048)
  set(image_view2_DEVEL_PREFIX /tmp/buildd/ros-hydro-image-view2-2.0.3-0raring-20150728-0048/obj-x86_64-linux-gnu/devel)
  set(image_view2_INSTALL_PREFIX "")
  set(image_view2_PREFIX ${image_view2_DEVEL_PREFIX})
else()
  set(image_view2_SOURCE_PREFIX "")
  set(image_view2_DEVEL_PREFIX "")
  set(image_view2_INSTALL_PREFIX /opt/ros/hydro)
  set(image_view2_PREFIX ${image_view2_INSTALL_PREFIX})
endif()

# warn when using a deprecated package
if(NOT "" STREQUAL "")
  set(_msg "WARNING: package 'image_view2' is deprecated")
  # append custom deprecation text if available
  if(NOT "" STREQUAL "TRUE")
    set(_msg "${_msg} ()")
  endif()
  message("${_msg}")
endif()

# flag project as catkin-based to distinguish if a find_package()-ed project is a catkin project
set(image_view2_FOUND_CATKIN_PROJECT TRUE)

if(NOT "include;/opt/ros/hydro/include/opencv;/opt/ros/hydro/include;/usr/include/pcl-1.7;/usr/include/eigen3;/usr/include;/usr/include/ni;/usr/include/vtk-5.8;/usr/include/qhull" STREQUAL "")
  set(image_view2_INCLUDE_DIRS "")
  set(_include_dirs "include;/opt/ros/hydro/include/opencv;/opt/ros/hydro/include;/usr/include/pcl-1.7;/usr/include/eigen3;/usr/include;/usr/include/ni;/usr/include/vtk-5.8;/usr/include/qhull")
  foreach(idir ${_include_dirs})
    if(IS_ABSOLUTE ${idir} AND IS_DIRECTORY ${idir})
      set(include ${idir})
    elseif("${idir}" STREQUAL "include")
      get_filename_component(include "${image_view2_DIR}/../../../include" ABSOLUTE)
      if(NOT IS_DIRECTORY ${include})
        message(FATAL_ERROR "Project 'image_view2' specifies '${idir}' as an include dir, which is not found.  It does not exist in '${include}'.  Ask the maintainer 'Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>' to fix it.")
      endif()
    else()
      message(FATAL_ERROR "Project 'image_view2' specifies '${idir}' as an include dir, which is not found.  It does neither exist as an absolute directory nor in '/opt/ros/hydro/${idir}'.  Ask the maintainer 'Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>' to fix it.")
    endif()
    _list_append_unique(image_view2_INCLUDE_DIRS ${include})
  endforeach()
endif()

set(libraries "/opt/ros/hydro/lib/libopencv_videostab.so.2.4.9;/opt/ros/hydro/lib/libopencv_video.so.2.4.9;/opt/ros/hydro/lib/libopencv_superres.so.2.4.9;/opt/ros/hydro/lib/libopencv_stitching.so.2.4.9;/opt/ros/hydro/lib/libopencv_photo.so.2.4.9;/opt/ros/hydro/lib/libopencv_ocl.so.2.4.9;/opt/ros/hydro/lib/libopencv_objdetect.so.2.4.9;/opt/ros/hydro/lib/libopencv_nonfree.so.2.4.9;/opt/ros/hydro/lib/libopencv_ml.so.2.4.9;/opt/ros/hydro/lib/libopencv_legacy.so.2.4.9;/opt/ros/hydro/lib/libopencv_imgproc.so.2.4.9;/opt/ros/hydro/lib/libopencv_highgui.so.2.4.9;/opt/ros/hydro/lib/libopencv_gpu.so.2.4.9;/opt/ros/hydro/lib/libopencv_flann.so.2.4.9;/opt/ros/hydro/lib/libopencv_features2d.so.2.4.9;/opt/ros/hydro/lib/libopencv_core.so.2.4.9;/opt/ros/hydro/lib/libopencv_contrib.so.2.4.9;/opt/ros/hydro/lib/libopencv_calib3d.so.2.4.9;optimized;/usr/lib/libpcl_common.so;debug;/usr/lib/libpcl_common.so;optimized;/usr/lib/libpcl_kdtree.so;debug;/usr/lib/libpcl_kdtree.so;optimized;/usr/lib/libpcl_octree.so;debug;/usr/lib/libpcl_octree.so;optimized;/usr/lib/libpcl_search.so;debug;/usr/lib/libpcl_search.so;optimized;/usr/lib/libpcl_sample_consensus.so;debug;/usr/lib/libpcl_sample_consensus.so;optimized;/usr/lib/libpcl_filters.so;debug;/usr/lib/libpcl_filters.so;optimized;/usr/lib/libpcl_features.so;debug;/usr/lib/libpcl_features.so;optimized;/usr/lib/libpcl_registration.so;debug;/usr/lib/libpcl_registration.so;optimized;/usr/lib/libpcl_io.so;debug;/usr/lib/libpcl_io.so;optimized;/usr/lib/libpcl_visualization.so;debug;/usr/lib/libpcl_visualization.so;optimized;/usr/lib/libpcl_segmentation.so;debug;/usr/lib/libpcl_segmentation.so;optimized;/usr/lib/libpcl_people.so;debug;/usr/lib/libpcl_people.so;optimized;/usr/lib/libpcl_surface.so;debug;/usr/lib/libpcl_surface.so;optimized;/usr/lib/libpcl_recognition.so;debug;/usr/lib/libpcl_recognition.so;optimized;/usr/lib/libpcl_keypoints.so;debug;/usr/lib/libpcl_keypoints.so;optimized;/usr/lib/libpcl_outofcore.so;debug;/usr/lib/libpcl_outofcore.so;optimized;/usr/lib/libpcl_tracking.so;debug;/usr/lib/libpcl_tracking.so;optimized;/usr/lib/libpcl_apps.so;debug;/usr/lib/libpcl_apps.so;/usr/lib/libboost_signals-mt.so;/usr/lib/libboost_system-mt.so;/usr/lib/libboost_filesystem-mt.so;/usr/lib/libboost_thread-mt.so;pthread;/usr/lib/libboost_date_time-mt.so;/usr/lib/libboost_iostreams-mt.so;/usr/lib/libboost_serialization-mt.so;optimized;/usr/lib/libqhull.so;debug;/usr/lib/libqhull.so;/usr/lib/libOpenNI.so;optimized;/usr/lib/libflann_cpp_s.a;debug;/usr/lib/libflann_cpp_s.a;/usr/lib/libvtkCommon.so.5.8.0;/usr/lib/libvtkRendering.so.5.8.0;/usr/lib/libvtkHybrid.so.5.8.0;/usr/lib/libvtkCharts.so.5.8.0")
foreach(library ${libraries})
  # keep build configuration keywords, target names and absolute libraries as-is
  if("${library}" MATCHES "^debug|optimized|general$")
    list(APPEND image_view2_LIBRARIES ${library})
  elseif(TARGET ${library})
    list(APPEND image_view2_LIBRARIES ${library})
  elseif(IS_ABSOLUTE ${library})
    list(APPEND image_view2_LIBRARIES ${library})
  else()
    set(lib_path "")
    set(lib "${library}-NOTFOUND")
    # since the path where the library is found is returned we have to iterate over the paths manually
    foreach(path /opt/ros/hydro/lib;/opt/ros/hydro/lib)
      find_library(lib ${library}
        PATHS ${path}
        NO_DEFAULT_PATH NO_CMAKE_FIND_ROOT_PATH)
      if(lib)
        set(lib_path ${path})
        break()
      endif()
    endforeach()
    if(lib)
      _list_append_unique(image_view2_LIBRARY_DIRS ${lib_path})
      list(APPEND image_view2_LIBRARIES ${lib})
    else()
      # as a fall back for non-catkin libraries try to search globally
      find_library(lib ${library})
      if(NOT lib)
        message(FATAL_ERROR "Project '${PROJECT_NAME}' tried to find library '${library}'.  The library is neither a target nor built/installed properly.  Did you compile project 'image_view2'?  Did you find_package() it before the subdirectory containing its code is included?")
      endif()
      list(APPEND image_view2_LIBRARIES ${lib})
    endif()
  endif()
endforeach()

set(image_view2_EXPORTED_TARGETS "image_view2_gencfg;image_view2_generate_messages_cpp;image_view2_generate_messages_lisp;image_view2_generate_messages_py")
# create dummy targets for exported code generation targets to make life of users easier
foreach(t ${image_view2_EXPORTED_TARGETS})
  if(NOT TARGET ${t})
    add_custom_target(${t})
  endif()
endforeach()

set(depends "roscpp;cv_bridge;std_msgs;sensor_msgs;geometry_msgs;image_transport;tf;image_geometry;message_filters")
foreach(depend ${depends})
  string(REPLACE " " ";" depend_list ${depend})
  # the package name of the dependency must be kept in a unique variable so that it is not overwritten in recursive calls
  list(GET depend_list 0 image_view2_dep)
  list(LENGTH depend_list count)
  if(${count} EQUAL 1)
    # simple dependencies must only be find_package()-ed once
    if(NOT ${image_view2_dep}_FOUND)
      find_package(${image_view2_dep} REQUIRED)
    endif()
  else()
    # dependencies with components must be find_package()-ed again
    list(REMOVE_AT depend_list 0)
    find_package(${image_view2_dep} REQUIRED ${depend_list})
  endif()
  _list_append_unique(image_view2_INCLUDE_DIRS ${${image_view2_dep}_INCLUDE_DIRS})

  # merge build configuration keywords with library names to correctly deduplicate
  _pack_libraries_with_build_configuration(image_view2_LIBRARIES ${image_view2_LIBRARIES})
  _pack_libraries_with_build_configuration(_libraries ${${image_view2_dep}_LIBRARIES})
  _list_append_deduplicate(image_view2_LIBRARIES ${_libraries})
  # undo build configuration keyword merging after deduplication
  _unpack_libraries_with_build_configuration(image_view2_LIBRARIES ${image_view2_LIBRARIES})

  _list_append_unique(image_view2_LIBRARY_DIRS ${${image_view2_dep}_LIBRARY_DIRS})
  list(APPEND image_view2_EXPORTED_TARGETS ${${image_view2_dep}_EXPORTED_TARGETS})
endforeach()

set(pkg_cfg_extras "image_view2-msg-extras.cmake")
foreach(extra ${pkg_cfg_extras})
  if(NOT IS_ABSOLUTE ${extra})
    set(extra ${image_view2_DIR}/${extra})
  endif()
  include(${extra})
endforeach()
